/*
 * User Mode Sandbox for Grid
 * Copyright (C) 2004 Tangui Morlier
 * Copyright (C) 2004 Grand-Large (INRIA Futurs)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
#ifndef COMMON_H
#define COMMON_H
#include <sys/user.h>
#include <linux/ptrace.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <limits.h>

#ifdef VERBOSE_PLUS
#define VERBOSE
#endif //VERBOSE_PLUS

#define NB_SYSCALLS 500
#define MAX_PATH_SIZE PATH_MAX
#define MAX_MSG_SIZE 255
#define MAX_PID_INFO 255

#define SIGBARRIER SIGPROF


struct ptrace_info_struct {
  struct user_regs_struct regs;
  pid_t pid;
  int in_or_out;
};


char cwd[MAX_PATH_SIZE];

struct pid_info {
  struct ptrace_info_struct pi;
  //int in_or_out;
  int barrier;
  int sig2forward;
  int filterSyscall;
  int fork_param;
  int wait_execve_success;
  int last_syscall;
  char * str;
  char msg[MAX_MSG_SIZE];
}pid_infos[MAX_PID_INFO];

#endif //COMMON_H
